from icarus.result.result_classes import SearchResult

__author__ = 'shillaker'


# Builds the result of a select query
def build_select_result(raw_response):
    result = SearchResult()
    result.n_total = raw_response['response'].get('numFound')
    result.items = raw_response['response'].get('docs')

    result.facet_counts = handle_facet_response(raw_response)

    return result


# Constructs our desired facet structure from a response
def handle_facet_response(response):

    # Build desired facet counts object
    facet_counts = None
    if 'facet_counts' in response.keys() and 'facet_fields' in response['facet_counts']:
        raw_facet_counts = response['facet_counts']['facet_fields']

        # Build up list of tuples from facets
        facet_counts = dict()
        for field, facets in raw_facet_counts.iteritems():
            filter_tuples = list()
            for i in xrange(0, len(facets), 2):
                filter_tuples.append((facets[i], facets[i + 1]))

            facet_counts[field] = filter_tuples

    return facet_counts
